# -*- coding: utf-8 -*-
from msilib.schema import ComboBox
from PySide import QtGui
from PySide import QtCore
import FreeCAD
from FreeCAD import Base
import FreeCAD, Part, math
from math import pi
import FreeCAD as App
from RcStr_data import ParamRCStairs

type=['RCStairs','RCStairs wth RCRail','RCStairs ALRail']
ichi=['Right','Left']


class ViewProvider:
    def __init__(self, obj):
        '''Set this object to the proxy object of the actual view provider'''
        obj.Proxy = self
        
class Ui_Dialog(object):
    def setupUi(self, Dialog):
        Dialog.setObjectName("Dialog")
        Dialog.resize(400, 330)
        Dialog.move(800, 0)
        #形式
        self.label = QtGui.QLabel('Format',Dialog)
        self.label.setGeometry(QtCore.QRect(10, 10, 100, 21))
        self.label.setObjectName("label")
        self.comboBox = QtGui.QComboBox(Dialog)
        self.comboBox.setGeometry(QtCore.QRect(150, 10, 140, 22))
        self.comboBox.setObjectName("comboBox")
        #L
        self.label_L = QtGui.QLabel('L[mm]',Dialog)
        self.label_L.setGeometry(QtCore.QRect(10, 36, 81, 21))
        self.label_L.setObjectName("label_L")
        self.lineEdit_L = QtGui.QLineEdit('2000',Dialog)
        self.lineEdit_L.setGeometry(QtCore.QRect(150, 36, 60, 22))
        self.lineEdit_L.setObjectName("lineEdit_L")
        #H
        self.label_H = QtGui.QLabel('H[mm]',Dialog)
        self.label_H.setGeometry(QtCore.QRect(10, 62, 81, 20))
        self.label_H.setObjectName("label_H")
        self.lineEdit_H = QtGui.QLineEdit('1500',Dialog)
        self.lineEdit_H.setGeometry(QtCore.QRect(150, 62, 60, 22))
        self.lineEdit_H.setObjectName("lineEdit_H")
        #W
        self.label_W = QtGui.QLabel('W[mm]',Dialog)
        self.label_W.setGeometry(QtCore.QRect(10, 88, 81, 20))
        self.label_W.setObjectName("label_W")
        self.lineEdit_W = QtGui.QLineEdit('1200',Dialog)
        self.lineEdit_W.setGeometry(QtCore.QRect(150, 88, 60, 22))
        self.lineEdit_W.setObjectName("lineEdit_W")
        #段数
        self.label_n = QtGui.QLabel('No of stages',Dialog)
        self.label_n.setGeometry(QtCore.QRect(10, 114, 81, 20))
        self.label_n.setObjectName("label_n")
        self.lineEdit_n = QtGui.QLineEdit('8',Dialog)
        self.lineEdit_n.setGeometry(QtCore.QRect(150, 114, 60, 22))
        self.lineEdit_n.setObjectName("lineEdit_W")
        #図形ラベル
        self.label_7 = QtGui.QLabel(Dialog)
        self.label_7.setGeometry(QtCore.QRect(220, 40, 165, 200))
        self.label_7.setText("")
        self.label_7.setScaledContents(True)
        self.label_7.setAlignment(QtCore.Qt.AlignCenter)
        #実行
        self.pushButton = QtGui.QPushButton('Create',Dialog)
        self.pushButton.setGeometry(QtCore.QRect(290, 270, 75, 23))
        self.pushButton.setObjectName("pushButton")

        #L1
        self.label_L1 = QtGui.QLabel('Slab length L1[mm]',Dialog)
        self.label_L1.setGeometry(QtCore.QRect(10, 140, 140, 20))
        self.lineEdit_L1 = QtGui.QLineEdit('2000',Dialog)
        self.lineEdit_L1.setGeometry(QtCore.QRect(150, 140, 60, 22))

        #W1
        self.label_W1 = QtGui.QLabel('Slab width W1[mm]',Dialog)
        self.label_W1.setGeometry(QtCore.QRect(10, 165, 140, 20))
        self.lineEdit_W1 = QtGui.QLineEdit('2600',Dialog)
        self.lineEdit_W1.setGeometry(QtCore.QRect(150, 165, 60, 22))

        #t1
        self.label_t1 = QtGui.QLabel('Slab thickness t1[mm]',Dialog)
        self.label_t1.setGeometry(QtCore.QRect(10, 190, 140, 20))
        self.lineEdit_t1 = QtGui.QLineEdit('150',Dialog)
        self.lineEdit_t1.setGeometry(QtCore.QRect(150, 190, 60, 22))

        #t2
        self.label_t2 = QtGui.QLabel('Slab thickness t2[mm]',Dialog)
        self.label_t2.setGeometry(QtCore.QRect(10, 215, 140, 20))
        self.lineEdit_t2 = QtGui.QLineEdit('150',Dialog)
        self.lineEdit_t2.setGeometry(QtCore.QRect(150, 215, 60, 22))
        
        #右回りcheckbox
        self.checkbox = QtGui.QCheckBox('TurnRight',Dialog)
        self.checkbox.setGeometry(QtCore.QRect(10, 240, 120, 23))
        self.checkbox.setChecked(True)
        #中間階checkbox3
        self.checkbox3= QtGui.QCheckBox('Middle floor',Dialog)
        self.checkbox3.setGeometry(QtCore.QRect(150, 240, 120, 23))
        self.checkbox3.setChecked(False)
        #手すり両側checkbox4
        self.checkbox4= QtGui.QCheckBox('Both Railings',Dialog)
        self.checkbox4.setGeometry(QtCore.QRect(290, 240, 120, 23))
        self.checkbox4.setChecked(False)

        #階数
        self.label_kai = QtGui.QLabel('Stories',Dialog)
        self.label_kai.setGeometry(QtCore.QRect(10, 270, 140, 20))
        self.lineEdit_kai = QtGui.QLineEdit('2',Dialog)
        self.lineEdit_kai.setGeometry(QtCore.QRect(150, 270, 60, 22))
        
        self.comboBox.addItems(type)
        self.comboBox.setCurrentIndex(1)
        self.comboBox.currentIndexChanged[int].connect(self.onType)
        self.comboBox.setCurrentIndex(0)

        self.checkbox.toggled.connect(self.onType)
        QtCore.QObject.connect(self.pushButton, QtCore.SIGNAL("pressed()"), self.create)
        QtCore.QMetaObject.connectSlotsByName(Dialog)

    def onType(self):
        global key
        key = self.comboBox.currentIndex()

        if key==0:
            img='RC階段'
        elif key==1:
            img='RC階段_RC'

        elif key==2:
            img='RC階段_AL' 

        pic=img+'.jpg'
        base=os.path.dirname(os.path.abspath(__file__))
        joined_path = os.path.join(base, "RcStr_data",pic)
        self.label_7.setPixmap(QtGui.QPixmap(joined_path))

    def create(self):
        global c1
        global L
        global H
        global x
        global y
        global n0
        global t1
        global t2
        global b
        global h1
        if key==0:
            label='RCStairs'
        elif key==1:
            label='RCStairs with RChandrail'  
        elif key==2:
            label='RCStairs with ALhandrail'  
        L=float(self.lineEdit_L.text())
        H=float(self.lineEdit_H.text())
        W=float(self.lineEdit_W.text())
        L1=float(self.lineEdit_L1.text())
        W1=float(self.lineEdit_W1.text())
        t1=float(self.lineEdit_t1.text())
        t2=float(self.lineEdit_t2.text())
        n0=int(self.lineEdit_n.text())
        n1=int(self.lineEdit_kai.text())
        obj = App.ActiveDocument.addObject("Part::FeaturePython",label)

        obj.addProperty("App::PropertyEnumeration", "Type",'Type')
        obj.Type = type
        i=self.comboBox.currentIndex()
        obj.Type=type[i]

        obj.addProperty("App::PropertyFloat", "L",'Dimension').L=L
        obj.addProperty("App::PropertyFloat", "H",'Dimension').H=H
        obj.addProperty("App::PropertyFloat", "W",'Dimension').W=W
        obj.addProperty("App::PropertyFloat", "L1",'Dimension').L1=L1
        obj.addProperty("App::PropertyFloat", "W1",'Dimension').W1=W1
        obj.addProperty("App::PropertyFloat", "t1",'Dimension').t1=t1
        obj.addProperty("App::PropertyFloat", "t2",'Dimension').t2=t2
        obj.addProperty("App::PropertyInteger", "n0",'no of stage').n0=n0 #段数
        obj.addProperty("App::PropertyInteger", "n1",'stories').n1=n1 # 階数
     
        if self.checkbox3.isChecked():
            obj.addProperty("App::PropertyBool",'MdlFloor',label).MdlFloor = True
        else:
            obj.addProperty("App::PropertyBool",'MdlFloor',label).MdlFloor = False
        if self.checkbox.isChecked():
            obj.addProperty("App::PropertyBool",'TurnRight',label).TurnRight = True
        else:
            obj.addProperty("App::PropertyBool",'TurnRight',label).TurnRight = False

        if self.checkbox4.isChecked():
            obj.addProperty("App::PropertyBool",'BothRailing',label).BothRailing = True
        else:
            obj.addProperty("App::PropertyBool",'BothRailing',label).BothRailing = False    

       
        ParamRCStairs.Stairs(obj)
        obj.ViewObject.Proxy=0
        FreeCAD.ActiveDocument.recompute() 

class Main_P():
        w = QtGui.QWidget()
        w.ui = Ui_Dialog()
        w.ui.setupUi(w)
        w.show()

#if __name__=='__main__':
#   Main_P()
