import FreeCAD
from FreeCAD import Base
import FreeCAD, Part, math
from math import pi
import FreeCAD as App
class Stairs:
    def __init__(self, obj):
        self.Type = 'Stairs'
        obj.Proxy = self
        App.activeDocument().recompute(None,True,True)
    def execute(self, obj):
        label=obj.Name
        Type=App.ActiveDocument.getObject(label).Type
        L=App.ActiveDocument.getObject(label).L
        L1=App.ActiveDocument.getObject(label).L1
        H=App.ActiveDocument.getObject(label).H
        W=App.ActiveDocument.getObject(label).W
        W1=App.ActiveDocument.getObject(label).W1
        w0=W1-2*W
        t1=App.ActiveDocument.getObject(label).t1
        t2=App.ActiveDocument.getObject(label).t2
        n0=App.ActiveDocument.getObject(label).n0
        n1=App.ActiveDocument.getObject(label).n1
        MdlFloor=App.ActiveDocument.getObject(label).MdlFloor
        TurnRight=App.ActiveDocument.getObject(label).TurnRight
        BothRailing=App.ActiveDocument.getObject(label).BothRailing
        x=L/(n0-1)
        y=H/n0
        s=math.atan(H/(L+x))
        a=t1/math.tan(s)
        h1=1100.0
        if a>x:
            t1=y
            b=0.01
        else:    
            b=x-a

        def hontai(sef):
            global c00    
            p1=(0,0,0)  
            p2=(x,0,0) 
            p3=(L+2*x,0,H)
            p4=(L+2*x,0,H)
            p5=(x,0,y)
            p6=(0,0,y)
            p7=(x,0,2*y)
            p8=(2*x,0,2*y)
            p9=(0,0,H)
            p10=(L,0,H)
            p11=(0,0,-t1)
            p12=(b,0,-t1)
            if MdlFloor==True:
                edge1=Part.makeLine(p11,p12)
                edge2=Part.makeLine(p12,p3)
                edge3=Part.makeLine(p3,p9)
                edge4=Part.makeLine(p9,p11)
            else:
                edge1=Part.makeLine(p1,p2)
                edge2=Part.makeLine(p2,p3)
                edge3=Part.makeLine(p3,p9)
                edge4=Part.makeLine(p9,p1)
            aWire=Part.Wire([edge1,edge2,edge3,edge4])
            pface=Part.Face(aWire)
            c00=pface.extrude(Base.Vector(0,W,0))
            for i in range(n0-1):
                pface=Part.makePlane((i+1)*(H-(i+1)*y),(i+1)*x,Base.Vector(0,0,(i+1)*y),Base.Vector(0,1,0))
                c01=pface.extrude(Base.Vector(0,W,0))
                c00=c00.cut(c01)
            p1=(L,0,H)
            p2=(L,-W1,H)
            p3=(L+L1,-W1,H)
            p4=(L+L1,0,H)
            edge1=Part.makeLine(p1,p2)
            edge2=Part.makeLine(p2,p3)
            edge3=Part.makeLine(p3,p4)
            edge4=Part.makeLine(p4,p1)
            aWire=Part.Wire([edge1,edge2,edge3,edge4])
            pface=Part.Face(aWire)
            w0=W1-2*W
            if TurnRight==False:
                c01=pface.extrude(Base.Vector(0,0,-t2))
                c01.Placement=App.Placement(App.Vector(0,W1,0),App.Rotation(App.Vector(0,1,0),0))
                c00=c00.fuse(c01)
            else:
                c01=pface.extrude(Base.Vector(0,0,-t2))
                c01.Placement=App.Placement(App.Vector(0,W,0),App.Rotation(App.Vector(0,1,0),0))    
                c00=c00.fuse(c01)
            c00=c00.removeSplitter()

        def RCRail(self):
            global c00
            #てすり階段部分
            p4=(L+x,0,H)
            p6=(0,0,y)
            p10=(0,0,y+1100) 
            p11=(L,0,H+1100) 
            p12=(L+x,0,H+1100) 
            p13=(x,0,y) 
            p14=(L,0,H)  
            edge10=Part.makeLine(p6,p10)  
            edge11=Part.makeLine(p10,p11) 
            edge12=Part.makeLine(p11,p14)  
            edge13=Part.makeLine(p14,p4)   
            edge14=Part.makeLine(p4,p13)  
            edge15=Part.makeLine(p13,p6) 
            aWire=Part.Wire([edge10,edge11,edge12,edge13,edge14,edge15])
            pface=Part.Face(aWire)
            c01=pface.extrude(Base.Vector(0,100,0))

            if TurnRight==True:
                c01.Placement=App.Placement(App.Vector(0,0,0),App.Rotation(App.Vector(0,1,0),0))
            else:
                c01.Placement=App.Placement(App.Vector(0,W-100,0),App.Rotation(App.Vector(0,1,0),0))
            c00=c00.fuse(c01)

            #てすり　スラブ部分
            c=W1-2*W
            if c<0:
                return
            plane = Part.makePlane(1100, 100, Base.Vector(L, (c+100), H), Base.Vector(0, 1, 0))
            c01=plane.extrude(Base.Vector(0,-(c+200),0)) 

            if TurnRight==False:
                c01.Placement=App.Placement(App.Vector(0,(W1-(W+200)),0),App.Rotation(App.Vector(0,1,0),0))
            else:
                c01.Placement=App.Placement(App.Vector(0,W1-2*(W+200),0),App.Rotation(App.Vector(0,1,0),0))    
                c00=c00.fuse(c01)
            c00=c00.fuse(c01)
            c00=c00.removeSplitter()
        def RCRail_1(self):
            global c00
            #てすり階段部分
            p4=(L+x,0,H)
            p6=(0,0,y)
            p10=(0,0,y+1100) 
            p11=(L,0,H+1100) 
            p12=(L+x,0,H+1100) 
            p13=(x,0,y) 
            p14=(L,0,H)  
            edge10=Part.makeLine(p6,p10)  
            edge11=Part.makeLine(p10,p11) 
            edge12=Part.makeLine(p11,p14)  
            edge13=Part.makeLine(p14,p4)   
            edge14=Part.makeLine(p4,p13)  
            edge15=Part.makeLine(p13,p6) 
            aWire=Part.Wire([edge10,edge11,edge12,edge13,edge14,edge15])
            pface=Part.Face(aWire)
            c01=pface.extrude(Base.Vector(0,100,0))

            if TurnRight==False:
                c01.Placement=App.Placement(App.Vector(0,0,0),App.Rotation(App.Vector(0,1,0),0))
            else:
                c01.Placement=App.Placement(App.Vector(0,W-100,0),App.Rotation(App.Vector(0,1,0),0))
            c00=c00.fuse(c01)

            #c00=c00.removeSplitter()    
        def ALRail(self):
            global c00
            #てすり階段部分笠木
            s=math.atan((H-y)/(L)) 
            h0=H-y
            dy=H+h1-(y+h1)
            dx=dy/math.tan(s)
            p1=(-x/2-40,85,0)
            p2=(-x/2-40,85,h1+y-50)
            p3=(0,85,h1+y-50)
            p4=(dx,85,H+h1-50)
            p5=(L+x/2+35,85,H+h1-50)
            p6=(-x/2-40,85,y+100)
            p7=(0,85,y+100)
            p8=(dx,85,H+100)
            p9=(L+x/2+35-5,85,H+100)
            p12=(-x/2,85-35,h1+y-50)
            p13=(-x/2,85-35,h1+y)
            p14=(-x/2,(85+70)-35,h1+y)
            p15=(-x/2,(85+70)-35,h1+y-50)
            p16=(-x/2,85-22.5,y+100-33)
            p17=(-x/2,85-22.5,y+100)
            p18=(-x/2,(85+45)-22.5,y+100)
            p19=(-x/2,(85+45)-22.5,y+100-33)
            edge1=Part.makeLine(p2,p3)
            edge2=Part.makeLine(p3,p4)
            edge3=Part.makeLine(p4,p5)
            edge4=Part.makeLine(p12,p13)
            edge5=Part.makeLine(p13,p14)
            edge6=Part.makeLine(p14,p15)
            edge7=Part.makeLine(p15,p12)
            edge8=Part.makeLine(p6,p7)
            edge9=Part.makeLine(p7,p8)
            edge10=Part.makeLine(p8,p9)
            edge11=Part.makeLine(p16,p17)
            edge12=Part.makeLine(p17,p18)
            edge13=Part.makeLine(p18,p19)
            edge14=Part.makeLine(p19,p16)
            aWire=Part.Wire([edge1,edge2,edge3])
            profile = Part.Wire([edge4,edge5,edge6,edge7])
            makeSolid=True
            isFrenet=True
            c01 = Part.Wire(aWire).makePipeShell([profile],makeSolid,isFrenet)
            aWire=Part.Wire([edge8,edge9,edge10])
            profile = Part.Wire([edge11,edge12,edge13,edge14])
            makeSolid=True
            isFrenet=True
            c02 = Part.Wire(aWire).makePipeShell([profile],makeSolid,isFrenet)
            c01=c01.fuse(c02)
            if TurnRight==False:
                c01.Placement=App.Placement(App.Vector(0,W-2*85,0),App.Rotation(App.Vector(0,1,0),0))
            c00=c00.fuse(c01)
            #支柱
            a=150*math.tan(s)
            c02=Part.makeBox(60,60,h1+80+a,Base.Vector(-x/2-40,55,0),Base.Vector(0,0,1))
            c03=Part.makeBox(60,60,h1,Base.Vector(L+x/2+10-40,55,H),Base.Vector(0,0,1))
            c02=c02.fuse(c03)
            if TurnRight==False:
                c02.Placement=App.Placement(App.Vector(0,W-2*85,),App.Rotation(App.Vector(0,1,0),0))
            c01=c01.fuse(c02)
            c00=c00.fuse(c01)
            c00=c00.removeSplitter()
            n1=int((L-x/2)/150)+1
            x0=float(L/n1)
            for i in range(n1+1):
                a=20*math.tan(s)
                c=h1-(100+a)
                p1=(0,0,0)
                p2=(0,0,c)
                p3=(20,0,c+a)
                p4=(20,0,a)
                wire=Part.makePolygon([p1,p2,p3,p4,p1])
                pface=Part.Face(wire)
                c000=pface.extrude(Base.Vector(0,20,0))
                c02=c000
                if i==0:
                    y1=y+150
                else:
                    y1=x0*math.tan(s)   
                c02.Placement=App.Placement(App.Vector(-170+(i+1)*x0,85,i*y1+y+25+40),App.Rotation(App.Vector(0,0,1),0))
                c01=c01.fuse(c02)
            x1=-30
            x0=float(L/n1)
            for i in range(n1+1):
                #lattice
                a=20*math.tan(s)
                c=h1-(100+a)
                p1=(0,0,0)
                p2=(0,0,c)
                p3=(20,0,c+a)
                p4=(20,0,a)
                wire=Part.makePolygon([p1,p2,p3,p4,p1])
                pface=Part.Face(wire)
                c01=pface.extrude(Base.Vector(0,20,0))
                if i==0:
                    y1=y+150
                else:
                    y1=x0*math.tan(s)  
                c01.Placement=App.Placement(App.Vector(-170+(i+1)*x0,85-10,i*y1+y+25+40),App.Rotation(App.Vector(0,0,1),0))
                if TurnRight==False:
                    c01.Placement=App.Placement(App.Vector(-170+(i+1)*x0,W-85+25-35,i*y1+y+25+40),App.Rotation(App.Vector(0,0,1),0))
                c00=c00.fuse(c01)
            #てすりスラブ部分
            c=W1-2*(W-55)
            if c<0 :
                pass
            plane = Part.makePlane(50, 70, Base.Vector(L+x/2+35-70, 85-35, H+h1-50), Base.Vector(0, 1, 0))
            c01=plane.extrude(Base.Vector(0,-c,0))
            if TurnRight==False:
                c01.Placement=App.Placement(App.Vector(0,W-2*85+380,0),App.Rotation(App.Vector(0,0,1),0))
            plane = Part.makePlane(33, 45, Base.Vector(L+x/2+35-70+12.5, 70-12.5, H+100), Base.Vector(0, 1, 0))
            c02=plane.extrude(Base.Vector(0,-(c+7.5),0))
            if TurnRight==False:
                c02.Placement=App.Placement(App.Vector(0,W-2*85+380-7.5,0),App.Rotation(App.Vector(0,0,1),0))
            c01=c01.fuse(c02)
            c00=c00.fuse(c01) 
            c00=c00.removeSplitter()
            #ラチス
            for i in range(2):
                if i==0:
                    c01=Part.makeBox(20,20,h1-(50+133),Base.Vector(L+x/2+15-25,-(i*150)+55+20-150,H+133),Base.Vector(0,0,1))
                else:    
                    c02=Part.makeBox(20,20,h1-(50+133),Base.Vector(L+x/2+15-25,-(i*150)+55+20-150,H+133),Base.Vector(0,0,1))
                    c01=c01.fuse(c02)
            if TurnRight==False:
                c01.Placement=App.Placement(App.Vector(0,W+280,0),App.Rotation(App.Vector(0,0,1),0))
            c00=c00.fuse(c01)
        def RCRail(self):
            global c00
            #てすり階段部分
            p4=(L+x,0,H)
            p6=(0,0,y)
            p10=(0,0,y+1100) 
            p11=(L,0,H+1100) 
            p12=(L+x,0,H+1100) 
            p13=(x,0,y) 
            p14=(L,0,H)  
            edge10=Part.makeLine(p6,p10)  
            edge11=Part.makeLine(p10,p11) 
            edge12=Part.makeLine(p11,p14)  
            edge13=Part.makeLine(p14,p4)   
            edge14=Part.makeLine(p4,p13)  
            edge15=Part.makeLine(p13,p6) 
            aWire=Part.Wire([edge10,edge11,edge12,edge13,edge14,edge15])
            pface=Part.Face(aWire)
            c01=pface.extrude(Base.Vector(0,100,0))

            if TurnRight==True:
                c01.Placement=App.Placement(App.Vector(0,0,0),App.Rotation(App.Vector(0,1,0),0))
            else:
                c01.Placement=App.Placement(App.Vector(0,W-100,0),App.Rotation(App.Vector(0,1,0),0))
            c00=c00.fuse(c01)

            #てすり　スラブ部分
            c=W1-2*W
            if c<0:
                return
            plane = Part.makePlane(1100, 100, Base.Vector(L, (c+100), H), Base.Vector(0, 1, 0))
            c01=plane.extrude(Base.Vector(0,-(c+200),0)) 

            if TurnRight==False:
                c01.Placement=App.Placement(App.Vector(0,(W1-(W+w0)),0),App.Rotation(App.Vector(0,1,0),0))
            else:
                c01.Placement=App.Placement(App.Vector(0,W1-2*(W+w0),0),App.Rotation(App.Vector(0,1,0),0))    
                c00=c00.fuse(c01)
            c00=c00.fuse(c01)
            c00=c00.removeSplitter()
        def RCRail_1(self):
            global c00
            #てすり階段部分
            p4=(L+x,0,H)
            p6=(0,0,y)
            p10=(0,0,y+1100) 
            p11=(L,0,H+1100) 
            p12=(L+x,0,H+1100) 
            p13=(x,0,y) 
            p14=(L,0,H)  
            edge10=Part.makeLine(p6,p10)  
            edge11=Part.makeLine(p10,p11) 
            edge12=Part.makeLine(p11,p14)  
            edge13=Part.makeLine(p14,p4)   
            edge14=Part.makeLine(p4,p13)  
            edge15=Part.makeLine(p13,p6) 
            aWire=Part.Wire([edge10,edge11,edge12,edge13,edge14,edge15])
            pface=Part.Face(aWire)
            c01=pface.extrude(Base.Vector(0,100,0))

            if TurnRight==False:
                c01.Placement=App.Placement(App.Vector(0,0,0),App.Rotation(App.Vector(0,1,0),0))
            else:
                c01.Placement=App.Placement(App.Vector(0,W-100,0),App.Rotation(App.Vector(0,1,0),0))
            c00=c00.fuse(c01)

            #c00=c00.removeSplitter()    
        def ALRail(self):
            global c00
            #てすり階段部分笠木
            s=math.atan((H-y)/(L)) 
            h0=H-y
            dy=H+h1-(y+h1)
            dx=dy/math.tan(s)
            p1=(-x/2-40,85,0)
            p2=(-x/2-40,85,h1+y-50)
            p3=(0,85,h1+y-50)
            p4=(dx,85,H+h1-50)
            p5=(L+x/2+35,85,H+h1-50)
            p6=(-x/2-40,85,y+100)
            p7=(0,85,y+100)
            p8=(dx,85,H+100)
            p9=(L+x/2+35-5,85,H+100)
            p12=(-x/2,85-35,h1+y-50)
            p13=(-x/2,85-35,h1+y)
            p14=(-x/2,(85+70)-35,h1+y)
            p15=(-x/2,(85+70)-35,h1+y-50)
            p16=(-x/2,85-22.5,y+100-33)
            p17=(-x/2,85-22.5,y+100)
            p18=(-x/2,(85+45)-22.5,y+100)
            p19=(-x/2,(85+45)-22.5,y+100-33)
            edge1=Part.makeLine(p2,p3)
            edge2=Part.makeLine(p3,p4)
            edge3=Part.makeLine(p4,p5)
            edge4=Part.makeLine(p12,p13)
            edge5=Part.makeLine(p13,p14)
            edge6=Part.makeLine(p14,p15)
            edge7=Part.makeLine(p15,p12)
            edge8=Part.makeLine(p6,p7)
            edge9=Part.makeLine(p7,p8)
            edge10=Part.makeLine(p8,p9)
            edge11=Part.makeLine(p16,p17)
            edge12=Part.makeLine(p17,p18)
            edge13=Part.makeLine(p18,p19)
            edge14=Part.makeLine(p19,p16)
            aWire=Part.Wire([edge1,edge2,edge3])
            profile = Part.Wire([edge4,edge5,edge6,edge7])
            makeSolid=True
            isFrenet=True
            c01 = Part.Wire(aWire).makePipeShell([profile],makeSolid,isFrenet)
            aWire=Part.Wire([edge8,edge9,edge10])
            profile = Part.Wire([edge11,edge12,edge13,edge14])
            makeSolid=True
            isFrenet=True
            c02 = Part.Wire(aWire).makePipeShell([profile],makeSolid,isFrenet)
            c01=c01.fuse(c02)
            if TurnRight==False:
                c01.Placement=App.Placement(App.Vector(0,W-2*85,0),App.Rotation(App.Vector(0,1,0),0))
            c00=c00.fuse(c01)
            #支柱
            a=150*math.tan(s)
            c02=Part.makeBox(60,60,h1+80+a,Base.Vector(-x/2-40,55,0),Base.Vector(0,0,1))
            c03=Part.makeBox(60,60,h1,Base.Vector(L+x/2+10-40,55,H),Base.Vector(0,0,1))
            c02=c02.fuse(c03)
            if TurnRight==False:
                c02.Placement=App.Placement(App.Vector(0,W-2*85,),App.Rotation(App.Vector(0,1,0),0))
            c01=c01.fuse(c02)
            c00=c00.fuse(c01)
            c00=c00.removeSplitter()
            n1=int((L-x/2)/150)+1
            x0=float(L/n1)
            for i in range(n1+1):
                a=20*math.tan(s)
                c=h1-(100+a)
                p1=(0,0,0)
                p2=(0,0,c)
                p3=(20,0,c+a)
                p4=(20,0,a)
                wire=Part.makePolygon([p1,p2,p3,p4,p1])
                pface=Part.Face(wire)
                c000=pface.extrude(Base.Vector(0,20,0))
                c02=c000
                if i==0:
                    y1=y+150
                else:
                    y1=x0*math.tan(s)   
                c02.Placement=App.Placement(App.Vector(-170+(i+1)*x0,85,i*y1+y+25+40),App.Rotation(App.Vector(0,0,1),0))
                c01=c01.fuse(c02)
            x1=-30
            x0=float(L/n1)
            for i in range(n1+1):
                #lattice
                a=20*math.tan(s)
                c=h1-(100+a)
                p1=(0,0,0)
                p2=(0,0,c)
                p3=(20,0,c+a)
                p4=(20,0,a)
                wire=Part.makePolygon([p1,p2,p3,p4,p1])
                pface=Part.Face(wire)
                c01=pface.extrude(Base.Vector(0,20,0))
                if i==0:
                    y1=y+150
                else:
                    y1=x0*math.tan(s)  
                c01.Placement=App.Placement(App.Vector(-170+(i+1)*x0,85-10,i*y1+y+25+40),App.Rotation(App.Vector(0,0,1),0))
                
                if TurnRight==False:
                    c01.Placement=App.Placement(App.Vector(-170+(i+1)*x0,W-85+25-35,i*y1+y+25+40),App.Rotation(App.Vector(0,0,1),0))
                c00=c00.fuse(c01)
            #てすりスラブ部分
            c=W1-2*W
            w0=W1-2*W
            if w0<0:
                w0=0
            if c<0 :
                c=0
                #pass
            plane = Part.makePlane(50, 70, Base.Vector(L+x/2+35-70, 85-35, H+h1-50), Base.Vector(0, 1, 0))
            c01=plane.extrude(Base.Vector(0,-c,0))
            if TurnRight==False:
                c01.Placement=App.Placement(App.Vector(0,W+w0/2,0),App.Rotation(App.Vector(0,0,1),0))
            plane = Part.makePlane(33, 45, Base.Vector(L+x/2+35-70+12.5, 70-12.5, H+100), Base.Vector(0, 1, 0))
            c02=plane.extrude(Base.Vector(0,-(c+7.5),0))
            if TurnRight==False:
                c02.Placement=App.Placement(App.Vector(0,W-2*85+380-7.5+w0-200,0),App.Rotation(App.Vector(0,0,1),0))
            c01=c01.fuse(c02)
            c00=c00.fuse(c01) 
            c00=c00.removeSplitter()
            #ラチス
            n2=int(c/200)
            for i in range(n2):
                if i==0:
                    c01=Part.makeBox(20,20,h1-(50+133),Base.Vector(L+x/2+15-25,-(i*150)+55+20-150,H+133),Base.Vector(0,0,1))
                else:    
                    c02=Part.makeBox(20,20,h1-(50+133),Base.Vector(L+x/2+15-25,-(i*150)+55+20-150,H+133),Base.Vector(0,0,1))
                    c01=c01.fuse(c02)
            if TurnRight==False:
                c01.Placement=App.Placement(App.Vector(0,W+w0,0),App.Rotation(App.Vector(0,0,1),0))
            c00=c00.fuse(c01)  
        def ALRail_1(self):
            global c00
            #てすり階段部分笠木
            s=math.atan((H-y)/(L)) 
            h0=H-y
            dy=H+h1-(y+h1)
            dx=dy/math.tan(s)
            p1=(-x/2-40,85,0)
            p2=(-x/2-40,85,h1+y-50)
            p3=(0,85,h1+y-50)
            p4=(dx,85,H+h1-50)
            p5=(L+x/2+35,85,H+h1-50)
            p6=(-x/2-40,85,y+100)
            p7=(0,85,y+100)
            p8=(dx,85,H+100)
            p9=(L+x/2+35-5,85,H+100)
            p12=(-x/2,85-35,h1+y-50)
            p13=(-x/2,85-35,h1+y)
            p14=(-x/2,(85+70)-35,h1+y)
            p15=(-x/2,(85+70)-35,h1+y-50)
            p16=(-x/2,85-22.5,y+100-33)
            p17=(-x/2,85-22.5,y+100)
            p18=(-x/2,(85+45)-22.5,y+100)
            p19=(-x/2,(85+45)-22.5,y+100-33)
            edge1=Part.makeLine(p2,p3)
            edge2=Part.makeLine(p3,p4)
            edge3=Part.makeLine(p4,p5)
            edge4=Part.makeLine(p12,p13)
            edge5=Part.makeLine(p13,p14)
            edge6=Part.makeLine(p14,p15)
            edge7=Part.makeLine(p15,p12)
            edge8=Part.makeLine(p6,p7)
            edge9=Part.makeLine(p7,p8)
            edge10=Part.makeLine(p8,p9)
            edge11=Part.makeLine(p16,p17)
            edge12=Part.makeLine(p17,p18)
            edge13=Part.makeLine(p18,p19)
            edge14=Part.makeLine(p19,p16)
            aWire=Part.Wire([edge1,edge2,edge3])
            profile = Part.Wire([edge4,edge5,edge6,edge7])
            makeSolid=True
            isFrenet=True
            c01 = Part.Wire(aWire).makePipeShell([profile],makeSolid,isFrenet)
            aWire=Part.Wire([edge8,edge9,edge10])
            profile = Part.Wire([edge11,edge12,edge13,edge14])
            makeSolid=True
            isFrenet=True
            c02 = Part.Wire(aWire).makePipeShell([profile],makeSolid,isFrenet)
            c01=c01.fuse(c02)
            if TurnRight==True:
                c01.Placement=App.Placement(App.Vector(0,W-2*85,0),App.Rotation(App.Vector(0,1,0),0))
            c00=c00.fuse(c01)
            #支柱
            a=150*math.tan(s)
            c02=Part.makeBox(60,60,h1+80+a,Base.Vector(-x/2-40,55,0),Base.Vector(0,0,1))
            c03=Part.makeBox(60,60,h1,Base.Vector(L+x/2+10-40,55,H),Base.Vector(0,0,1))
            c02=c02.fuse(c03)
            if TurnRight==True:
                c02.Placement=App.Placement(App.Vector(0,W-2*85,),App.Rotation(App.Vector(0,1,0),0))
            c01=c01.fuse(c02)
            c00=c00.fuse(c01)
            c00=c00.removeSplitter()
            n1=int((L-x/2)/150)+1
            x0=float(L/n1)
            for i in range(n1+1):
                a=20*math.tan(s)
                c=h1-(100+a)
                p1=(0,0,0)
                p2=(0,0,c)
                p3=(20,0,c+a)
                p4=(20,0,a)
                wire=Part.makePolygon([p1,p2,p3,p4,p1])
                pface=Part.Face(wire)
                c000=pface.extrude(Base.Vector(0,20,0))
                c02=c000
                if i==0:
                    y1=y+150
                else:
                    y1=x0*math.tan(s)   
                c02.Placement=App.Placement(App.Vector(-170+(i+1)*x0,85,i*y1+y+25+40),App.Rotation(App.Vector(0,0,1),0))
                c01=c01.fuse(c02)
            x1=-30
            x0=float(L/n1)
            for i in range(n1+1):
                #lattice
                a=20*math.tan(s)
                c=h1-(100+a)
                p1=(0,0,0)
                p2=(0,0,c)
                p3=(20,0,c+a)
                p4=(20,0,a)
                wire=Part.makePolygon([p1,p2,p3,p4,p1])
                pface=Part.Face(wire)
                c01=pface.extrude(Base.Vector(0,20,0))
                if i==0:
                    y1=y+150
                else:
                    y1=x0*math.tan(s)  
                c01.Placement=App.Placement(App.Vector(-170+(i+1)*x0,85-10,i*y1+y+25+40),App.Rotation(App.Vector(0,0,1),0))
                if TurnRight==True:
                    c01.Placement=App.Placement(App.Vector(-170+(i+1)*x0,W-85+25-35,i*y1+y+25+40),App.Rotation(App.Vector(0,0,1),0))
                c00=c00.fuse(c01)

        if Type=='RCStairs':
            for i in range(n1-1):
                if i==0:
                    label=obj.Name
                    hontai(self) 
                    c1=c00 
                else:
                    label=obj.Name
                    if i % 2==0:
                        hontai(self) 
                        c2=c00  
                        c2.Placement=App.Placement(App.Vector(0,0,i*H),App.Rotation(App.Vector(0,0,1),0))     
                    else:
                        MdlFloor=True
                        hontai(self) 
                        c2=c00  
                        if TurnRight==True:
                            c2.Placement=App.Placement(App.Vector(L,-w0,i*H),App.Rotation(App.Vector(0,0,1),180))     
                        else:
                            c2.Placement=App.Placement(App.Vector(L,W1,i*H),App.Rotation(App.Vector(0,0,1),180))     
                    c1=c1.fuse(c2)
        elif Type=='RCStairs wth RCRail':
            for i in range(n1-1):
                if i==0:
                    label=obj.Name
                    hontai(self) 
                    c1=c00
                    RCRail(self)
                    c2=c00
                    c1=c1.fuse(c2) 
                    c1=c1.removeSplitter()
                    if BothRailing==True:
                        RCRail_1(self)
                        c2=c00
                        c1=c1.fuse(c2) 
                        c1=c1.removeSplitter()
                else:
                    label=obj.Name
                    if i % 2==0:
                        hontai(self) 
                        c2=c00  
                        RCRail(self)
                        c3=c00
                        c2=c2.fuse(c3) 
                        c2.Placement=App.Placement(App.Vector(0,0,i*H),App.Rotation(App.Vector(0,0,1),0))     
                        c2=c2.removeSplitter()
                        c1=c1.fuse(c2)
                        if BothRailing==True:
                            RCRail_1(self)
                            c2=c00
                            c2.Placement=App.Placement(App.Vector(0,0,i*H),App.Rotation(App.Vector(0,0,1),0))     
                            c1=c1.fuse(c2) 
                            c1=c1.removeSplitter()
                    else:
                        MdlFloor=True
                        hontai(self) 
                        c4=c00  
                        RCRail(self)
                        c5=c00
                        c4=c4.fuse(c5) 
                        
                        if TurnRight==True:
                            c4.Placement=App.Placement(App.Vector(L,-w0,i*H),App.Rotation(App.Vector(0,0,1),180)) 
                        else:
                            c4.Placement=App.Placement(App.Vector(L,W1,i*H),App.Rotation(App.Vector(0,0,1),180))  
                        c1=c1.fuse(c4)

                        if BothRailing==True:
                            RCRail_1(self)
                            c5=c00
                            if TurnRight==True:
                                c5.Placement=App.Placement(App.Vector(L,-w0,i*H),App.Rotation(App.Vector(0,0,1),180)) 
                            else:
                                c5.Placement=App.Placement(App.Vector(L,W1,i*H),App.Rotation(App.Vector(0,0,1),180))  
                            c1=c1.fuse(c5) 
                        c1=c1.removeSplitter()

        elif Type=='RCStairs ALRail':
            for i in range(n1-1):
                if i==0:
                    label=obj.Name
                    hontai(self) 
                    c1=c00
                    ALRail(self)
                    c2=c00
                    c1=c1.fuse(c2) 
                    if BothRailing==True:
                        ALRail_1(self)
                        c2=c00
                        c1=c1.fuse(c2) 

                else:
                    label=obj.Name
                    if i % 2==0:
                        hontai(self) 
                        c2=c00
                        ALRail(self)
                        c3=c00
                        c2=c2.fuse(c3) 
                        c2.Placement=App.Placement(App.Vector(0,0,i*H),App.Rotation(App.Vector(0,0,1),0))     
                        #c2=c2.removeSplitter()
                        c1=c1.fuse(c2)
                        if BothRailing==True:
                            ALRail_1(self)
                            c2=c00
                            c2.Placement=App.Placement(App.Vector(0,0,i*H),App.Rotation(App.Vector(0,0,1),0))     
                            c1=c1.fuse(c2) 
                            #c1=c1.removeSplitter()
                    else:
                        MdlFloor=True
                        hontai(self) 
                        c4=c00
                        ALRail(self)
                        c5=c00
                        c4=c4.fuse(c5) 
                        if TurnRight==True:
                            c4.Placement=App.Placement(App.Vector(L,-w0,i*H),App.Rotation(App.Vector(0,0,1),180)) 
                        else:
                            c4.Placement=App.Placement(App.Vector(L,W1,i*H),App.Rotation(App.Vector(0,0,1),180))  
                        c1=c1.fuse(c4) 

                        if BothRailing==True:
                            ALRail_1(self)
                            c5=c00
                            if TurnRight==True:
                                c5.Placement=App.Placement(App.Vector(L,-w0,i*H),App.Rotation(App.Vector(0,0,1),180)) 
                            else:
                                c5.Placement=App.Placement(App.Vector(L,W1,i*H),App.Rotation(App.Vector(0,0,1),180))  
                            c1=c1.fuse(c5)
                        c1=c1.removeSplitter()        
        obj.Shape=c1